#include <PalmOS.h>
#include <VFSMgr.h>

#include "plugin.h"
#include "enum-db3vfs.h"
#include "db.h"
#include "io.h"
#include "iovfs.h"

#define GetObjectPtr(f,i) FrmGetObjectPtr((f),FrmGetObjectIndex((f),(i)))
#if 0
void CheckVolumes( void *plugData)
{
    UInt16 volRefNum;
    UInt32 volIterator = vfsIteratorStart;
    Char buf[255];

    while ( volIterator != vfsIteratorStop ) {
        if (VFSVolumeEnumerate(&volRefNum, &volIterator))
            DbgPrintF("Volume %ld error", volIterator);
        else {
            VFSVolumeGetLabel(volRefNum, buf, 255);
            DbgPrintF("Volume %ld: %s", volIterator, buf);
        }
    }
}
#endif

void MoveDatabase( void *plugData)
{
    DmOpenRef chooserRef;
    FormPtr form, oldForm;
    ListPtr lst;
    Char ** labelList;
    UInt16 i, numDatabases;
    ChooserRecord * record;
    MemHandle h;


    if (!DeviceSupportVFS())
        return;

    chooserRef = DmOpenDatabaseByTypeCreator('LIST', DBCreatorID, dmModeReadOnly);

    numDatabases = DmNumRecords(chooserRef);
    if (!numDatabases) {
        DmCloseDatabase(chooserRef);
        return;
    }
    labelList = MemPtrNew(numDatabases * sizeof(Char *));
    for (i = 0; i < numDatabases; i++) {
        h = DmQueryRecord(chooserRef, i);
        record = MemHandleLock(h);
        labelList[i] = record->title;
        MemPtrUnlock(record);
    }

    oldForm = FrmGetActiveForm();
    form = FrmInitForm(formID_DatabasesChooser);
    FrmSetActiveForm(form);

    lst = GetObjectPtr(form, ctlID_DatabasesChooser_List);
    LstSetListChoices(lst, labelList, numDatabases);

    if (FrmDoDialog(form) == ctlID_DatabasesChooser_OkayButton) {
        UInt16 selection = LstGetSelection(lst);

        if (selection != noListSelection) {
            h = DmQueryRecord(chooserRef, selection);
            record = MemHandleLock(h);
            
            VFSMoveDatabase(record->sourceID, (void *) (record + 1),
                                MemHandleSize(h) - sizeof(ChooserRecord));
            MemPtrUnlock(record);
        }
    }
    FrmDeleteForm(form);
    FrmSetActiveForm(oldForm);
    MemPtrFree(labelList);

    DmCloseDatabase(chooserRef);
}
#undef GetObjectPtr

void MainPlug(void *plugData)
{
    Plug_SetDriver(plugData, DBvfs_GetDriver());
    Plug_SetAboutAlert(plugData, alertID_AboutBox);
    Plug_SetAction(plugData, ActionRunInChooserSelector,
                            MoveDatabase);
}
