#ifndef __PLUG_H__
#define __PLUG_H__

#include "section.h"

typedef enum {
    PLUGINTYPE_ABOUTBOX = 0,
    PLUGINTYPE_CHOOSER,
    PLUGINTYPE_LISTVIEW,
    PLUGINTYPE_EDITVIEW,
    PLUGINTYPE_DATABASEINFO,
} PlugScreen;

typedef enum {
    FORM_OPEN = 0,
    FORM_CLOSE
} PlugMoment;

typedef struct {
    PlugScreen screen;
    PlugMoment moment;
    DataSource *source;
    UInt16 record;
} PlugEnvironement;

#define MAXPLUGIN 10

typedef struct {
    Char name[32];
    UInt16 shLibRef;
    DmOpenRef dbRef;
    MemHandle resH;
} Plugin;


typedef enum {
    selector = 0,
    autorun = 10,
    autorunclose = 20,
} Switcher;

extern Plugin PluginTable[];

struct grid_data;

extern Err Plug_Setup(void);
extern void Plug_Restore(void);
extern DataSourceDriver *Plug_GetDriver(void);
extern void Plug_ShowList( PlugEnvironement environement) PLUGINSECT;
extern void Plug_ShowAboutBox() PLUGINSECT;
extern Boolean PluginListHandleEvent( EventPtr event) PLUGINSECT;
extern Boolean Plug_CurrentPluginHandleEvent( EventPtr event) PLUGINSECT;
extern void Plug_AutoRun( PlugEnvironement environement) PLUGINSECT;
extern struct grid_data * Plug_GetGrid(void) PLUGINSECT;
extern void Plug_Execute(UInt16 pluginToLaunch, 
						 const PlugEnvironement environement, Switcher switcher) PLUGINSECT;

#endif
