#ifndef _PREFS_H
#define _PREFS_H

#include "db.h"
#include "grid.h"

#define prefFlagEnableFind      0x0001
#define prefFlagUpArrowPage     0x0002
#define prefFlagDownArrowPage   0x0004
#define prefFlagPageUpPage      0x0008
#define prefFlagPageDownPage    0x0010
#define prefFlagRecordUpPage    0x0020
#define prefFlagRecordDownPage  0x0040
#define prefFlagOpenRDWRMode    0x0080
#define prefFlagUnuseFilters    0x0100
#define prefFlagRRAfterEdit     0x0200
#define prefFlagAutoRunPlugin   0x0400
#define prefFlagHighResolution  0x0800
#define prefFlagIgnoreHelp      0x1000
#define prefFlagIgnoreMathLib   0x2000

#define chooserSortOrderAlphabetic 0
#define chooserSortOrderManual     1

typedef enum {

 prefID_GlobalPrefs = 0,
 prefID_LastDataSource, 
 prefID_GFind_DataSource, 
 prefID_GFind_sourceID, 
 prefID_LastPrefID                // this must always remain the last id

} prefsEnum;



/*Global Preferences declaration*/
typedef struct {
    /* Flags */
    UInt16 flags;

    /* Current chooser category. */
    UInt16 ChooserCurrentCategory;
    Boolean ChooserShowAllCategories;
    Boolean ChooserForceRescan;
    Boolean Unused[6];
    UInt8 ChooserSortOrder;

    /* Grid display*/
    UInt16 GridDisplay;
    UInt16 FloatDigits;
    UInt16 ColumnWidth;

    /* Font choice */
    FontID TheStdFont;
    FontID TheBoldFont;

} DBPrefsType, *DBPrefsPtr;





extern DBPrefsType DBPrefs;

extern void PopupDBPrefs(void) EDITSECT;
extern void InitPrefs(DBPrefsPtr prefs);

#endif
